/* ESERCIZIO (del 10-5-2018)
 Definire un ADT per oggetti che forniscano valori Non-Modificabili da 
 utilizzare in modo simile ai valori stack bounded di int introdotti
 da StackImm in slide di Lezione15. 
 Questo ADT deve trattare stack polimorfi e fornire le seguenti opera-
 zioni (con segnatura funzionale)
 	push: A -> Stack<A> -> Stack<A>
 	toString: Stack<A> -> String
 	top: Stack<A> -> A
 	pop: Stack<A> -> Stack<A>
 	size: Stack<A> -> int
 	isin: A -> Stack<A> -> boolean
 	waitUp: A ->Stack<A> -> int          (quanti prima)
 	addAll: Vector<A> -> Stack<A> -> Stack<A>
 	remove: A -> Stack<A> -> Stack<A>    (rimuove prima occorrenza)
 In aggiunta ad un costruttore che dato un intero n>0, costruisce uno 
 Stack<A> con bound n. 

 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
    1 per la API STACK<A>
    1 per la classe Stack<A>
    1 per le eccezioni, newExc
    1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
    (c) Fornire successiva operazione nell'ordine e 
        ad ogni definizione procedere con (d),(e),(f)
    (d) Completare la segnatura con le eccezioni sollevate
    (e) Aggiungere definizione classi di eccezioni relative
    (f) compilare ed eseguire test di uso
  */

package StackPack;

import java.io.*;
import java.util.*;

class Test1{
    public static void main(String[] args) throws EmptyStackException,
                                                  FullStackException{
        Stack<Integer> stack1 = new Stack<Integer>().empty(10).push(1).push(5);
        Stack<Integer> stack2 = stack1.push(12);
        System.out.println("stack1.top = " + stack1.top());
        System.out.println("stack2.top = " + stack2.top());
        System.out.println("stack1 = " + stack1.toString());
        System.out.println("stack2 = " + stack2.toString());
        //intrusione
        /* stack2.elm = 73;
            stack2.size = 3;  
        /* intrusione -- eecuzione concorrente
         while (true)
         {
         stack2.p[10] = 73;
         stack2.top = 10;
         stack2.n = 11;
         }
         */
    }
}
class Test2{
    public static void main(String[] args) throws EmptyStackException,
    FullStackException{
        Stack<Integer> starter = new Stack<Integer>();
        Stack<Integer> stack1 = starter.empty(10).push(1).push(5);
        Stack<Integer> stack2 = stack1.pop();
        Stack<Integer> stack3 = stack2.push(12);
        System.out.println("stack1 = " + stack1.toString());
        System.out.println("stack2 = " + stack2.toString());
        System.out.println("stack3 = " + stack3.toString());
    }
}
class Test3{
    public static void main(String[] args) throws EmptyStackException,
    FullStackException{
        Stack<Integer> starter = new Stack<Integer>();
        Stack<Integer> stack1 = starter.empty(10).push(1).push(5);
        Stack<Integer> stack2 = stack1.pop();
        Stack<Integer> stack3 = stack2.push(12);
        System.out.println("stack1.isin(12) = " + stack1.isin(12) + ";   stack1.size() = " + stack1.size());
        System.out.println("stack2.isin(12) = " + stack2.isin(12) + ";   stack2.size() = " + stack2.size());
        System.out.println("stack3.isin(12) = " + stack3.isin(12) + ";   stack3.size() = " + stack3.size());
    }
}
class Test4{//waitup
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> starter = new Stack<Integer>();
        Stack<Integer> stack1 = starter.empty(10).push(7).push(1).push(5);
        Stack<Integer> stack2 = stack1.pop();
        Stack<Integer> stack3 = stack1.push(12);
        System.out.println("stack1 = " + stack1.toString());
        try{
          System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
        try{
            System.out.println("stack2.waitUp(3) = " + stack1.waitUp(3));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
    }
}
class Test5{//addAll
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> starter = new Stack<Integer>();
        Stack<Integer> stack1 = starter.empty(10).push(7).push(1).push(5);
        Stack<Integer> stack2 = stack1.pop();
        Stack<Integer> stack3 = stack1.push(12);
        Vector<Integer> V = new Vector<Integer>();
        V.add(new Integer(12));
        V.add(new Integer(4));
        V.add(new Integer(11));
        V.add(new Integer(17));
        V.add(new Integer(-3));
        V.add(new Integer(-7));
        Stack<Integer> stack4 = stack1.addAll(V);
        System.out.println("stack4 = " + stack4.toString());
        try{
            System.out.println("stack4.waitUp(7) = " + stack4.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack4 non contiene 7");}
        try{
            System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
    }
}

class Test6{//remove
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> starter = new Stack<Integer>();
        Stack<Integer> stack1 = starter.empty(10).push(7).push(1).push(5);
        Stack<Integer> stack2 = stack1.pop();
        Stack<Integer> stack3 = stack1.push(12);
        Vector<Integer> V = new Vector<Integer>();
        V.add(new Integer(12));
        V.add(new Integer(4));
        V.add(new Integer(11));
        V.add(new Integer(17));
        V.add(new Integer(-3));
        V.add(new Integer(-7));
        Stack<Integer> stack4 = stack1.addAll(V);
        System.out.println("stack1 = " + stack1.toString());
        System.out.println("stack4 = " + stack4.toString());
        try{
            System.out.println("stack4.waitUp(7) = " + stack4.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack4 non contiene 7");}
        try{
            System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
        Stack<Integer> stack5 = stack4.remove(7);
        System.out.println("stack5 = " + stack5.toString());
        try{
            System.out.println("stack4.waitUp(7) = " + stack5.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack5 non contiene 7");}
        try{
            System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
    }
}
