/* ESERCIZIO (del 15-5-2018)
 Definire un ADT per Stack bounded POLIMORFI come quelli trattati il
 10-5-2018 ma MUTABLE. Questi valori devono avere le stesse operazio-
 ni di quelli IMMUTABLE e definiti in file organizzati similmente in
 una directory Mutable e in un package di StackPack.
 Le operazione hanno la seguente segnatura procedurale:
 
        empty: int -> Stack<A>            (dimensione massima)
        push: A -> Stack<A> -> Stack<A>
        toString: Stack<A> -> String
        top: Stack<A> -> A
        pop: Stack<A> -> void
        size: Stack<A> -> int
        isin: A -> Stack<A> -> boolean
        waitUp: A ->Stack<A> -> int       (quanti prima)
        addAll: Vector<A> -> Stack<A> -> void
        remove: A -> Stack<A> -> Svoid    (rimuove prima occorrenza)
 NOTA: push e' un costruttore.
 
 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
 1 per la API STACK<A>
 1 per la classe Stack<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */

package StackPack;
import java.util.*;

public interface API<A>{
	public API<A> empty(int n);
    public API<A> push(A x) throws FullStackException;
    public String toString();
    public A top() throws EmptyStackException;
    public void pop() throws EmptyStackException;
    public int size();
    public boolean isin(A x);
    public int waitUp(A x)throws NoSuchElementException;
    public void addAll(Vector<A> vv)throws FullStackException;
    public void remove(A x);
}

