/* ESERCIZIO (del 15-5-2018)
 Definire un ADT per Stack bounded POLIMORFI come quelli trattati il 
 10-5-2018 ma MUTABLE. Questi valori devono avere le stesse operazio-
 ni di quelli IMMUTABLE e definiti in file organizzati similmente in 
 una directory Mutable e in un package di StackPack.
 Le operazione hanno la seguente segnatura procedurale:
 
            empty: int -> Stack<A>           (dimensione massima)
            push: A -> Stack<A> -> Stack<A>
            toString: Stack<A> -> String
            top: Stack<A> -> A
            pop: Stack<A> -> void
            size: Stack<A> -> int
            isin: A -> Stack<A> -> boolean
            waitUp: A ->Stack<A> -> int       (quanti prima)
            addAll: Vector<A> -> Stack<A> -> void
            remove: A -> Stack<A> -> Svoid    (rimuove prima occorrenza)
 NOTA: push e' un costruttore.

 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
    1 per la API STACK<A>
    1 per la classe Stack<A>
    1 per le eccezioni, newExc
    1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
    (c) Fornire successiva operazione nell'ordine e 
        ad ogni definizione procedere con (d),(e),(f)
    (d) Completare la segnatura con le eccezioni sollevate
    (e) Aggiungere definizione classi di eccezioni relative
    (f) compilare ed eseguire test di uso
  */

package StackPack;

import java.io.*;
import java.util.*;

public class Stack<A> implements API<A>{
    private A elm;
    private Stack<A> next;
    private int size;
    private int max;
    /*
     AF(c) = [] iff (c.size = 0)
     AF(c) = [v1,...,vn] iff (c.size > 0)&&(c.size = n)&&
                          (vn = elm)&&
                          (AF(c.next) = [v1,...,vn-1])
     I(c) = (c.size >= 0)&&(c.size <= c.max)&&
            (c.size > 0 => c.elm != null) &&
            (c.size > 1 => c.next != null) &&
            (c.next != null => (c.next.max = c.max &&
                                c.next.size = c.size-1))
     */
    public Stack<A> empty(int n){
        Stack<A> ret = new Stack<A>();
        ret.max = n;
        return ret;
    }
    public void push(A x)throws FullStackException{
        if (size == max) throw new FullStackException("push",max);
        Stack<A> ret = new Stack<A>();
        ret.elm = elm;
        ret.next = next;
        ret.size = size;
        ret.max = max;
        elm = x;
        next = ret;
        size = size++;
    }
    public String toString(){
        if (size == 0) return "[ ]";
        if (size == 1) return "[" + elm.toString() + "]";
        String ret = next.toString();
        ret = ret.substring(0,ret.length()-1);
        return (ret + ", " + elm.toString() + "]");
    }
    public A top()throws EmptyStackException{
	    if (size == 0) throw new EmptyStackException("top");
	    return elm;
    }
    public void pop()throws EmptyStackException{
	    if (size == 0) throw new EmptyStackException("pop");
	    elm = next.elm;
        next = next.next;
        size--;
    }
    public int size(){
        return size;
    }
    public boolean isin(A x){
        if (size == 0) return false;
        return (elm.equals(x) || next.isin(x));
    }
    public int waitUp(A x)throws NoSuchElementException{
        if (!isin(x)) throw new NoSuchElementException("waitUp");
        if(elm.equals(x)) return 0;
        return (1 + next.waitUp(x));
    }
    public void addAll(Vector<A> vv)throws FullStackException{
        if (vv.size()+size > max) throw new FullStackException("addAll",size);
        for(int i=0; i<vv.size(); i++){
            push(vv.get(i));
        }
    }
    public void remove(A x){
        if (size == 0) return;
        if (elm.equals(x)){
            try {
                pop();
            }catch(EmptyStackException e){/*impossibile*/}
        }
        next.remove(x);;
        size = next.size() + 1;
    }
}

