/* ESERCIZIO (del 10-5-2018)
 Definire un ADT per oggetti che forniscano valori Non-Modificabili da
 utilizzare in modo simile ai valori stack bounded di int introdotti
 da StackImm in slide di Lezione15.
 Questo ADT deve trattare stack polimorfi e fornire le seguenti opera-
 zioni:
        push: A -> Stack<A> -> Stack<A>
        toString: Stack<A> -> String
        top: Stack<A> -> A
        pop: Stack<A> -> Stack<A>
        size: Stack<A> -> int
        isin: A -> Stack<A> -> boolean
        waitUp: A ->Stack<A> -> int          (quanti prima)
        addAll: Vector<A> -> Stack<A> -> Stack<A>
        remove: A -> Stack<A> -> Stack<A>    (rimuove prima occorrenza)
 In aggiunta ad un costruttore che dato un intero n>=0, costruisce uno 
 Stack<A> con bound n. 

 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
 1 per la API STACK<A>
 1 per la classe Stack<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso.
 */
package StackPack;

import java.io.*;
import java.util.*;

class Test1{
    public static void main(String[] args) 
    			throws EmptyStackException,FullStackException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.push(12);
        System.out.println("stack1.top = " + stack1.top());
        System.out.println("stack2.top = " + stack2.top());
        System.out.println("stack1 = " + stack1);
        System.out.println("stack2 = " + stack2);
        //intrusione
        /* stack2.elm = 73;
            stack2.size = 3;  
        /* intrusione -- eecuzione concorrente
         while (true)
         {
         stack2.p[10] = 73;
         stack2.top = 10;
         stack2.n = 11;
         }
         */
    }
}
class Test2{
    public static void main(String[] args) throws EmptyStackException,
    FullStackException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.pop();
        Stack<Integer> stack3 = stack2;
        stack3.push(12);
        System.out.println("stack1 = " + stack1);
        System.out.println("stack2 = " + stack2);
        System.out.println("stack3 = " + stack3);
    }
}
class Test3{
    public static void main(String[] args) throws EmptyStackException,
    FullStackException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
         stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.pop();
        Stack<Integer> stack3 = stack2;
        stack3.push(12);
        System.out.println("stack1.isin(12) = " + stack1.isin(12) + ";   stack1.size() = " + stack1.size());
        System.out.println("stack2.isin(12) = " + stack2.isin(12) + ";   stack2.size() = " + stack2.size());
        System.out.println("stack3.isin(12) = " + stack3.isin(12) + ";   stack3.size() = " + stack3.size());
    }
}
class Test4{//waitup
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.pop();
        Stack<Integer> stack3 = stack2;
        stack3.push(12);
        try{
          System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
        try{
            System.out.println("stack2.waitUp(1) = " + stack1.waitUp(1));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 1");}
    }
}
class Test5{//addAll
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.pop();
        Stack<Integer> stack3 = stack2;
        stack3.push(12);
        Vector<Integer> V = new Vector<Integer>();
        V.add(12);
        V.add(4);
        V.add(11);
        V.add(17);
        V.add(-3);
        V.add(-7);
        stack1.addAll(V);
        System.out.println("stack3 = " + stack3);
        try{
            System.out.println("stack2.waitUp(7) = " + stack2.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack2 non contiene 7");}
        try{
            System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
    }
}

class Test6{//remove
    //....
    public static void main(String[] args) throws EmptyStackException,
    FullStackException, NoSuchElementException{
        Stack<Integer> stack1 = new Stack<Integer>(30);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1;
        stack2.pop();
        Stack<Integer> stack3 = stack2;
        stack3.push(12);
        Vector<Integer> V = new Vector<Integer>();
        V.add(12);
        V.add(4);
        V.add(11);
        V.add(17);
        V.add(-3);
        V.add(-7);
        stack1.addAll(V);
        System.out.println("stack3 = " + stack3);
        Stack<Integer> stack4 = stack1;
        stack4.addAll(V);
        System.out.println("stack1 = " + stack1);
        System.out.println("stack4 = " + stack4);
        try{
            System.out.println("stack4.waitUp(7) = " + stack4.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack4 non contiene 7");}
        try{
            System.out.println("stack1.waitUp(7) = " + stack1.waitUp(7));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 7");}
        Stack<Integer> stack5 = stack4;
        stack4.remove(7);
        System.out.println("stack5 = " + stack5.toString());
        try{
            System.out.println("stack4.waitUp(4) = " + stack5.waitUp(4));
        }catch(NoSuchElementException e){System.out.println("stack5 non contiene 4");}
        try{
            System.out.println("stack1.waitUp(1) = " + stack1.waitUp(1));
        }catch(NoSuchElementException e){System.out.println("stack1 non contiene 1");}
    }
}

class Test7{//equals
    public static void main(String[] args) 
    			throws EmptyStackException,FullStackException,
    			       CloneNotSupportedException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = new Stack<Integer>(10);
        stack2.push(1);
        stack2.push(5);
        System.out.println("stack1 = " + stack1);
        System.out.println("stack2 = " + stack2);
        System.out.println("Is stack1 equals stack2 = " + stack1.equals(stack2));
        
    }
}

class Test8{//clone
    public static void main(String[] args) 
    			throws EmptyStackException,FullStackException,
    			       CloneNotSupportedException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1.clone();
        System.out.println("stack1 = " + stack1);
        System.out.println("stack2 = " + stack2);
        System.out.println("Is stack1 equals stack2 = " + stack1.equals(stack2));
        stack2.push(5);
        System.out.println("Is stack1 equals stack2 = " + stack1.equals(stack2)); 
        Stack<Integer> stack3 = new Stack<Integer>(3);  
        stack3.push(1);
        stack3.push(5);
        stack3.push(5);
        System.out.println("stack2 = " + stack2);
        System.out.println("stack3 = " + stack3);
        System.out.println("Is stack2 equals stack3 = " + stack2.equals(stack3)); 
    }
}

class Test9{//elements
    public static void main(String[] args) 
    			throws EmptyStackException,FullStackException,
    			       CloneNotSupportedException{
        Stack<Integer> stack1 = new Stack<Integer>(10);
        stack1.push(1);
        stack1.push(5);
        Stack<Integer> stack2 = stack1.clone();
        System.out.println("stack1 = " + stack1);
        System.out.println("stack2 = " + stack2);
        System.out.println("Is stack1 equals stack2 = " + stack1.equals(stack2));
        stack2.push(5);
        System.out.println("Is stack1 equals stack2 = " + stack1.equals(stack2)); 
        Stack<Integer> stack3 = new Stack<Integer>(3);  
        stack3.push(1);
        stack3.push(5);
        stack3.push(5);
        System.out.println("stack2 = " + stack2);
        System.out.println("stack3 = " + stack3);
        System.out.println("Is stack2 equals stack3 = " + stack2.equals(stack3));
        System.out.println("stack1.elements() is " + stack1.elements());
        System.out.println("stack3.elements() is " + stack3.elements());
    }
}

